#include <stdlib.h>
#include <alloc.h>
#include <stdio.h>
#include <conio.h>
#include "numero.h"

void ferm(numero *out, numero *a, numero *p) { // a - zaklad, p - exponent
  int usesys = (*out).getsys();
  numero s(usesys), t(usesys), tt(usesys);
  numero i(usesys), ii(usesys), j(usesys), pmj(usesys), one(usesys), ipj(usesys);

  one.add(1);
  s.copy(&one);
  j.add(0);
  pmj.copy(p);
  pmj.minus(&one);
  while (j.vetsi(&pmj) == -1) {
    t.copy(a);
    t.modulo(p);

    i.copy(&one);
    ipj.copy(&j);
    ipj.plus(&i);
    while (ipj.vetsi(p) == -1) {
      tt.copy(&t);
      t.krat(&tt);
      t.modulo(p);

      ii.copy(&i);
      i.plus(&ii);
      ipj.copy(&j);
      ipj.plus(&i);
    }
    s.krat(&t);
    s.modulo(p);

    i.minus(&ii);
    ipj.copy(&j);
    ipj.plus(&i);
    j.copy(&ipj);
  }

  (*out).copy(&s);
}

int isprime(numero *p) {
  int usesys = (*p).getsys();
  numero a(usesys), min(usesys), max(usesys), step(usesys), out(usesys), one(usesys);
  int pn = 1, k = 1;
  step.add(2);  // krok
  one.add(1);
  min.add(2);
  max.copy(p);
  for (a.copy(&min); a.vetsi(&max) == -1; a.plus(&step)) {
    ferm(&out, &a, p);
    k = out.resert();
    if (k != 1) { pn = 0; break; }
  }
  return pn;
}

int isprime(numero *p, long s) {
  int usesys = (*p).getsys();
  numero a(usesys), min(usesys), max(usesys), step(usesys), out(usesys), one(usesys);
  int pn = 1, k = 1;
  step.insert(s);
  one.add(1);
  min.add(1);
  max.copy(p);
  for (a.copy(&min); a.vetsi(&max) == -1; a.plus(&step)) {
    ferm(&out, &a, p);
    k = out.resert();
    if (k != 1) { pn = 0; break; }
  }
  return pn;
}

void main(void) {
  numero p;
  long k, l;

  FILE *f;
  char *soubor = "prime0.txt";
  f = fopen(soubor, "w");
  if (f == NULL) exit(1);

  clrscr();

  for (k = 1; k < 500; k ++) {
    p.insert(k);
    if (isprime(&p) == 1) {
      l = p.resert();
      printf("%ld\n", l);
      fprintf(f,"%ld\n", l);
    }
    if (kbhit()) break;
  }

  fclose(f);
}